



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>浅谈Java单例模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">浅谈Java单例模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-22 23:58:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>关于基本的懒汉式，饿汉式等写法网上介绍多如牛毛，这里不再赘述，直接讨论加了volatile关键字的双重锁（Double check），静态内部类以及枚举等写法，如有不对，恳请读者指出，欢迎讨论。</p>
<div>1.加了volatile关键字的双重锁：</div>
<div>
<div>
<div>
<pre class="prettyprint linenums">public class Singleton {<br />
    private static volatile Singleton singleton = null;

    private Singleton(){}

    public static Singleton getSingleton(){<br />
        if(singleton == null){<br />
            synchronized (Singleton.class){<br />
                if(singleton == null){<br />
                    singleton = new Singleton();<br />
                }<br />
            }<br />
        }<br />
        return singleton;<br />
    }<br />
}</pre>
</div>
</div>
</div>
<div>　　相信对单例模式有过了解的同学都知道，有了双重锁，效率应该是没问题的了，但是线程安全就不一定能保证的了。大家知道我们写的代码（尤其是多线程代码），由于编译器优化，在实际执行的时候可能与我们编写的顺序不同。</div>
<div> 　　编译器只保证程序执行结果与源代码相同，却不保证实际指令的顺序与源代码相同。这在单线程看起来没什么问题，然而一旦引入多线程，这种乱序就可能导致严重问题。原因在于singleton = new Sngleton();这句并非一个原子操作，实际上JVM在这句话中大概做了是三件事情：</div>
<div>1.给singleton分配内存；</div>
<div>2.调用Singleton的构造函数初始化成员变量，形成实例；</div>
<div>3.将singleton对象指向分配的内存空间（执行完这步singleton才是非null的）</div>
<div> 　　由于指令重排优化的存在，导致初始化Singleton和将对象地址赋给instance字段的顺序是不确定的。最终执行顺序可能是1-2-3，也可能是1-3-2，如果是后者，在某个线程创建单例对象时，在构造方法被调用之前，就为该对象分配了内存空间并将对象的字段设置为默认值。此时就可以将分配的内存地址赋值给instance字段了，然而该对象可能还没有初始化。若紧接着另外一个线程来调用getInstance，取到的就是未经初始化的对象，程序就会出错。（所谓指令重排优化是指在不改变原语义的情况下，通过调整指令的执行顺序让程序运行的更快。JVM中并没有规定编译器优化相关的内容，也就是说JVM可以自由的进行指令重排序的优化。）而volatile关键字就可以从语义上解决这个问题。使用volatile有两个功能：</div>
<div>1.这个变量不会在多个线程中存在副本，直接从内存中读取。</div>
<div>2.这个关键字会禁止指令重排优化也就是说，在volatile变量的赋值操作后面会有一个内存屏障，读操作不会被重排序到内存屏障之前。</div>
<div>
<p>下面这段话摘自《深入理解Java虚拟机》：</p>
<p>　　&ldquo;观察加入volatile关键字和没有加入volatile关键字时所生成的汇编代码发现，加入volatile关键字时，会多出一个lock前缀指令&rdquo;</p>
<p>　　lock前缀指令实际上相当于一个内存屏障（也成内存栅栏），内存屏障会提供3个功能：</p>
<p>　　1）它确保指令重排序时不会把其后面的指令排到内存屏障之前的位置，也不会把前面的指令排到内存屏障的后面；即在执行到内存屏障这句指令时，在它前面的操作已经全部完成；</p>
<p>　　2）它会强制将对缓存的修改操作立即写入主存；</p>
<p>　　3）如果是写操作，它会导致其他CPU中对应的缓存行无效。</p>
</div>
<div>&nbsp;</div>
<div>2.静态内部类(嵌套类)：</div>
<div>
<div>
<pre class="prettyprint linenums">public class Singleton {<br />
    private static class Holder {<br />
        private static Singleton singleton = new Singleton();<br />
    }

    private Singleton(){}

    public static Singleton getSingleton(){<br />
        return Holder.singleton;<br />
} </pre>
</div>
</div>
<div>
<div>&nbsp;</div>
</div>
<div>　　把Singleton实例放到一个静态内部类中，这样就避免了静态实例在Singleton类加载的时候就创建对象，实现了延迟加载，并且由于静态内部类只会被加载一次，所以这种写法也是线程安全的。</div>
<div>&nbsp;</div>
<div>3.枚举</div>
<div>　　使用枚举除了线程安全和防止反射强行调用构造器之外，还提供了自动序列化机制，防止反序列化的时候创建新的对象。因此，<a href="http://www.amazon.com/gp/product/B000WJOUPA/ref=as_li_qf_sp_asin_il_tl?ie=UTF8&amp;camp=1789&amp;creative=9325&amp;creativeASIN=B000WJOUPA&amp;linkCode=as2&amp;tag=job0ae-20" rel="external nofollow noreferrer">Effective Java</a>推荐尽可能地使用枚举来实现单例。</div>
<div>
<div>
<div>
<pre class="prettyprint linenums">public enum Singleton {<br />
    INSTANCE;<br />
    private String name;<br />
    public String getName(){<br />
        return name;<br />
    }<br />
    public void setName(String name){<br />
        this.name = name;<br />
    }<br />
}</pre>
</div>
</div>
</div>
<div>
<p>最后，不管采取何种方案，请时刻牢记单例的三大要点：</p>
<ul><li>线程安全</li>
<li>延迟加载</li>
<li>序列化与反序列化安全</li></ul>
<div>参考：</div>
<div>　　　　《Thinking in Java》&nbsp;</div>
<div>　　　　《深入理解Java虚拟机》</div>
<div>　　　　《Effective Java》</div>
<div>　　　　http://coolshell.cn/articles/265.html</div>
<div>　　　　http://www.iteye.com/topic/652440</div>
<div>　　　　http://www.cnblogs.com/dolphin0520/p/3920373.html</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j0w00q.html">237&period; Delete Node in a Linked List</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93wwpgq.html">iOS 开发快速导引：iOS 程序框架【草】</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m7ljp8.html">csu 1809 Parenthesis</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnxr629.html">设计模式之美：Facade（外观）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1gjmd9.html">NOIP201302表达式求值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yj44eq.html">MATLAB绘 透视图</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdnom48.html">TWaver初学实战&mdash;&mdash;基于HTML5的交互式地铁图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w0lewq.html">使用单用户模式破解Linux密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1jge8.html">Oracle中使用escape关键字实现like匹配特殊字符，以及&amp;字符的转义</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmzwel9.html">PL&sol;SQL中如何执行DDL、SCL&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04k0gq.html">你好，C&plus;&plus;（40）7&period;1  一切指针都是纸老虎：彻底理解指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pje2y8.html">Qt学习之路&lpar;49&rpar;&colon; 通用算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1wk7dq.html">android页面切换效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kkx369.html">Partitioner分区过程分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdpdxz9.html">Hibernate3 第二天</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo6jrxq.html">ROS学习记录（二）&mdash;&mdash;&mdash;&mdash;使用smartcar进行仿真&lpar;用&period;xacro文件来运行rviz&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjx44g8.html">我爱Java系列之《JavaEE学习笔记day12》---【缓冲流、转换流、序列&sol;反序列化流、打印流】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16v1yq.html">&lbrack;Swift&rsqb;LeetCode920&period; 播放列表的数量 &vert; Number of Music Playlists</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meon3pq.html">Kali Linux常用服务配置教程DHCP服务原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvwrkk8.html">java&lowbar;Arrays&period;sort&lpar;&rpar;方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxko5md8.html">NavigationControllerr滑动返回</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey53lz9.html">企业建站http&colon;&sol;&sol;www&period;douco&period;com&sol;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge4z278.html">PHPEXCEL实例-导出EXCEL</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoreo1q.html">使用 System&period;Transactions 进行事物管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mjkrj8.html">Spring&period;NET 的IOC&lpar;依赖注入&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kpdz49.html">poj 3641 &mdash;&mdash;2016&mdash;&mdash;3&mdash;&mdash;15</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge46ge8.html">js架构设计模式&mdash;&mdash;你对MVC、MVP、MVVM 三种组合模式分别有什么样的理解？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jmeyw8.html">js原生设计模式&mdash;&mdash;2面向对象编程之闭包1</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy14jx2q.html">MyBatis 延迟加载</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yd4pz8.html">Paxos 实现日志复制同步</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
